#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<bool> used;
vector<int> pairs;
vector<bool> wr;
vector<vector<int> > a;

int n, k;

const int INF = 1e9;

bool ans = false;

void check(int len) {
    if (ans) {
        return;
    }
    if (len == n) {
        int b1, b2;
        for (int i = 0; i < k ; i++) {
            b1 = -INF;
            b2 = INF;
            for (int j = 0; j < n; j++) {
                b1 = max(min(a[j][i], a[pairs[j]][i]), b1);
                b2 = min(max(a[j][i], a[pairs[j]][i]), b2);
            }
            if (b1 > b2) {
                return;
            }
        }
        ans = true;
        cout << "YES" << endl;
        for (int i = 0; i < n;  i++) {
            if (!wr[i]) {
                cout << i + 1 << " " << pairs[i] + 1 << endl;
                wr[i] = true;
                wr[pairs[i]] = true;
            }
        }
        return;
    }
    vector<int> unwr;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            unwr.push_back(i);
        }
    }
    used[unwr[0]] = true;
    for (int i = 1; i < (int)unwr.size(); i++) {
        pairs[unwr[0]] = unwr[i];
        pairs[unwr[i]] = unwr[0];
        used[unwr[i]] = true;
        check(len + 2);
        pairs[unwr[i]] = -1;
        used[unwr[i]] = false;
    }
    pairs[unwr[0]] = -1;
    used[unwr[0]] = false;
    return;
}

int main() {
    cin >> n >> k;
    used.resize(n);
    pairs.resize(n, -1);
    wr.resize(n);
    a.resize(n);
    for (int i = 0; i < n; i++) {
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }
    if (k == 1) {
        vector<pair<int, int> > val;
        for (int i = 0; i < n; i++) {
            val.push_back({a[i][0], i + 1});
        }
        sort(val.begin(), val.end());
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++) {
            cout << val[i].second << " " << val[n - 1 - i].second << endl;
        }
        return 0;
    }
    check(0);
    if (!ans) {
        cout << "NO" << endl;
    }
    return 0;
}
