#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    vector<int> b(n);
    vector<int> next(n, -1);
    vector<int> prev(n, -1);
    vector<bool> used(n);
    vector<int> num(n);
    vector<queue<int> > time(n);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        a[i]--;
        time[a[i]].push(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        b[i]--;
        num[b[i]] = i;
        if (i != 0) {
            prev[b[i]] = b[i - 1];
            next[b[i - 1]] = b[i];
        }
    }
    if (n == 1) {
        cout << n << endl;
        for (int i = 0; i < m; i++) {
            cout << 1 << " ";
        }
        return 0;
    }
    int s = b[0];
    int f = b[n - 1];
    vector<int> ans;
    int cnt = 0;
    for (int i = 0; i < m; i++) {
   /* int r = s;
    cout << "check " << endl;
    cout << s << endl;
    cout << next[s] << endl;
    cout << next[next[s]] << endl;
    cout << f << endl;*/
        while (s != a[i]) {
            used[s] = true;
            int v;
            if (time[s].empty()) {
                v = next[s];
                next[f] = s;
                prev[s] = f;
                next[s] = -1;
                prev[v] = -1;
                f = s;
                s = v;
                ans.push_back(n);
            }
            else {
                int t = time[s].front();
                int pos = -1;
                set<int> vert;
                for (int j = i; j < t; j++) {
                    vert.insert(a[j]);
                }
                int k = 0;
                int st = s;
                while (!vert.empty()) {
                    vert.erase(st);
                    st = next[st];
                    k++;
                }
                //cout << k << endl;
                ans.push_back(k);
                if (st == -1) {
                    st = f;
                    f = s;
                } else {
                    st = prev[st];
                }
                v = next[s];
                prev[v] = -1;
                int v2 = next[st];
                next[st] = s;
                prev[s] = st;
                next[s] = v2;
                if (v2 != -1) prev[v2] = s;
                s = v;
            }
            cnt++;
        }
        used[s] = true;
        time[s].pop();
        int v;
        if (time[s].empty()) {
            v = next[s];
            next[f] = s;
            prev[s] = f;
            next[s] = -1;
            prev[v] = -1;
            f = s;
            s = v;
            ans.push_back(n);
        }
        else {
            int t = time[s].front();
            int pos = -1;
            set<int> vert;
            for (int j = i + 1; j < t; j++) {
                vert.insert(a[j]);
            }
            int k = 0;
            int st = s;
            if (i < m - 1 && a[i] == a[i + 1]) {
                ans.push_back(1);
                cnt++;
                continue;
            }
            while (!vert.empty()) {
                vert.erase(st);
                st = next[st];
                k++;
            }
            ans.push_back(k);
            if (st == -1) {
                st = f;
                f = s;
            } else {
                st = prev[st];
            }
            v = next[s];
            prev[v] = -1;
            int v2 = next[st];
            next[st] = s;
            prev[s] = st;
            next[s] = v2;
            if (v2 != -1) prev[v2] = s;
            s = v;
        }
        cnt++;
        /*if (i == 2) {
            cout << endl << "aaaa";
            break;
       }*/
    }
    cout << cnt << endl;
    for (int i = 0; i < cnt; i++) {
        cout << ans[i] << " ";
    }
    cout << endl;
    return 0;
}
