#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const int MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1 << endl;
        return 0;
    }
    vector<vector<ll> > dp[2];
    dp[0].resize(n + 1);
    dp[1].resize(n + 1);
    for (int i = 0; i < n + 1; i++) {
        dp[0][i].resize(n + 1);
        dp[1][i].resize(n + 1);
    }
    dp[0][k][k] = 1;
    dp[1][k][k] = 1;

    for (int i = k; i < n + 1; i++) { // sum
        for (int j = 1; j < n + 1; j++) { // last_val
            for (int t = j + 1; t < n + 1; t++) {
                if (i + t > n) break;
                dp[0][i + t][t] += dp[1][i][j];
                dp[0][i + t][t] %= MOD;
            }
            for (int t = 1; t < j; t++) {
                if (i + t > n) break;
                dp[1][i + t][t] += dp[0][i][j];
                dp[1][i + t][t] %= MOD;
            }
        }
    }
    ll ans = 0;
    for (int i = 1; i < n + 1; i++) {
        ans += dp[0][n][i];
        ans += dp[1][n][i];
        ans %= MOD;
    }
    cout << ans << endl;
    return 0;
}
