#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > edges;
vector<int> vis;

int cnt;
int cnt_v;

void dfs(int v, int col = 1) {
    cnt_v++;
    if (col == 1) {
        cnt++;
    }
    vis[v] = true;
    for (int i = 0; i < (int)edges[v].size(); i++) {
        int u = edges[v][i];
        if (!vis[u]) {
            dfs(u, -col);
        }
    }
}

int main() {
    int n;
    cin >> n;
    edges.resize(n);
    vis.resize(n);
    int v;
    bool check = true;
    bool check2 = true;
    for (int i = 0; i < n; i++) {
        cin >> v;
        if (v == -1) {
            if (i != 0) {
                check = false;
            }
            continue;
        }
        v--;
        if (i == 0) {
            check = false;
        }
        if (v != i - 1) {
            check = false;
        }
        if (v >= i) {
            check2 = false;
        }
        edges[i].push_back(v);
        edges[v].push_back(i);
    }
    if (check) {
        cout << (n / 2) + (n % 2) << endl;
    }
    int ans = 0;
    if (check2) {
        for (int i = 0; i < n; i++) {
            cnt = 0;
            cnt_v = 0;
            if (!vis[i]) {
                dfs(i);
            }
            ans += max(cnt, cnt_v - cnt);
        }
        cout << ans << endl;
    }
    return 0;
}
