#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > edges;
vector<int> vis;
vector<int> pr;
vector<int> dp[2];

bool cycle;

void dfs(int v, int col = 1) {
    dp[1][v] = 1;
    vis[v] = true;
    for (int i = 0; i < (int)edges[v].size(); i++) {
        int u = edges[v][i];
        if (!vis[u]) {
            pr[u] = v;
            dfs(u, -col);
            dp[0][v] += max(dp[1][u], dp[0][u]);
            dp[1][v] += dp[0][u];
        } else {
            cycle = true;
        }
    }
}



int main() {
    int n;
    cin >> n;
    edges.resize(n);
    vis.resize(n);
    dp[0].resize(n);
    dp[1].resize(n);
    pr.resize(n);
    int v;
    bool check = true;
    bool check2 = true;
    for (int i = 0; i < n; i++) {
        cin >> v;
        if (v == -1) {
            if (i != 0) {
                check = false;
            }
            continue;
        }
        v--;
        if (i == 0) {
            check = false;
        }
        if (v != i - 1) {
            check = false;
        }
        if (v >= i) {
            check2 = false;
        }
        edges[i].push_back(v);
        edges[v].push_back(i);
    }
    if (check) {
        cout << (n / 2) + (n % 2) << endl;
        return 0;
    }
    int ans = 0;
    if (check2) {
        for (int i = 0; i < n; i++) {
            if (!vis[i]) {
                dfs(i);
                ans += max(dp[0][i], dp[1][i]);
            }
        }
        cout << ans << endl;
        return 0;
    }
    int x = (1 << 20);
    if (n <= 20) {
        int q;
        int qq;
        bool ch;
        int vert;
        for (int i = 1; i < x; i++) {
            vert = 0;
            ch = true;
            for (int j = 0; j < n; j++) {
                vis[j] = false;
            }
            q = 0;
            qq = i;
            while (qq > 0) {
                if (qq % 2 == 1) {
                    if (q > n - 1) {
                        break;
                    }
                    vis[q] = true;
                    vert++;
                }
                q++;
                qq /= 2;
            }
            for (int j = 0 ; j < n; j++) {
                for (int d = 0; d < edges[j].size(); d++){
                    int uu = edges[j][d];
                    if (vis[j] && vis[uu]) {
                        ch = false;
                        break;
                    }
                }
                if (!ch) {
                    break;
                }
            }
            if (!ch) {
                continue;
            }
            ans = max(ans, vert);
        }
    }
    cout << ans << endl;
    return 0;
}
